#include <xc.h>
#define _XTAL_FREQ 4000000
/** C O N F I G U R A T I O N   B I T S ******************************/

// CONFIG1H
#pragma config FOSC = INTIO67
#pragma config PLLCFG = OFF
#pragma config PRICLKEN = OFF
#pragma config FCMEN = OFF
#pragma config IESO = OFF

// CONFIG2L
#pragma config PWRTEN = OFF
#pragma config BOREN = SBORDIS
#pragma config BORV = 190

// CONFIG2H
#pragma config WDTEN = OFF
#pragma config WDTPS = 32768

// CONFIG3H
#pragma config CCP2MX = PORTC1
#pragma config PBADEN = OFF
#pragma config CCP3MX = PORTC6
#pragma config HFOFST = OFF
#pragma config T3CMX = PORTC0
//#pragma config P2BMX = PORTD2
#pragma config MCLRE = EXTMCLR

// CONFIG4L
#pragma config STVREN = ON
#pragma config LVP = OFF
#pragma config XINST = OFF

// CONFIG5L
#pragma config CP0 = OFF
#pragma config CP1 = OFF
#pragma config CP2 = OFF
#pragma config CP3 = OFF

// CONFIG5H
#pragma config CPB = OFF
#pragma config CPD = OFF

// CONFIG6L
#pragma config WRT0 = OFF
#pragma config WRT1 = OFF
#pragma config WRT2 = OFF
#pragma config WRT3 = OFF

// CONFIG6H
#pragma config WRTC = OFF
#pragma config WRTB = OFF
#pragma config WRTD = OFF

// CONFIG7L
#pragma config EBTR0 = OFF
#pragma config EBTR1 = OFF
#pragma config EBTR2 = OFF
#pragma config EBTR3 = OFF

// CONFIG7H
#pragma config EBTRB = OFF


#include <stdio.h>

#define PS2_TAKT    PORTAbits.RA1
#define PS2_DATEN   PORTAbits.RA0
#define STATUS_LED  LATAbits.LA2
#define CPLD    LATB



void delay_100ms(unsigned char n);
unsigned char PS2_Bit_Holen();
unsigned char PS2_Lesen();


void main (void)
{
    unsigned char Tastenkode, Matrix;

    OSCCONbits.IRCF2=1;
    OSCCONbits.IRCF1=0;
    OSCCONbits.IRCF2=1;

    TRISA = 0b11111011;     	// PORTC bits 1:0 are outputs (0)
    ANSELAbits.ANSA0=0;
    ANSELAbits.ANSA1=0;
    ANSELAbits.ANSA2=0;
    TRISB = 0;     	// PORTC bits 1:0 are outputs (0)
    ANSELB = 0;
    PORTB=0;
    CPLD = 0xff;



        STATUS_LED = 1;
        delay_100ms(5);	    // Delay 50 x 1000 = 50,000 cycles; 200ms @ 1MHz
        STATUS_LED = 0;
        delay_100ms(5);	    // Delay 50 x 1000 = 50,000 cycles; 200ms @ 1MHz


    while (1)
    {
        Tastenkode=PS2_Lesen();
        switch (Tastenkode)
        {
            case 0xf0: //Losgelassen
                Tastenkode=PS2_Lesen();
                Tastenkode=0;
                break;
            case 0xaa: //Selbsttest
                Tastenkode=0;
                break;
            case 0xe0: //Sonderzeichen
                Tastenkode=PS2_Lesen();
                if (Tastenkode==0xf0)
                {
                    Tastenkode=PS2_Lesen();
                    Tastenkode=0;
                    break;
                }
                Tastenkode=PS2_Lesen();
            default:
                break;
        }
        if (Tastenkode==0)
        {
            CPLD=0xff;
            STATUS_LED = 0;
        }
        else
        {
            switch (Tastenkode)
            {
		//0001		Pfeil |	=	Shift	Space
                case 0x75: Matrix=0b10001110; break;   //Pfeil nach oben
		case 0x0D: Matrix=0b10001101; break;   //TAB -> =
		case 0x12: Matrix=0b10001011; break;   //L-Shift
		case 0x59: Matrix=0b10001011; break;   //R-Shift
		case 0x29: Matrix=0b10000111; break;   //Space
		//0010		1	Q	A	Y
		case 0x16: Matrix=0b01001110; break;   //1
		case 0x15: Matrix=0b01001101; break;   //Q
		case 0x1C: Matrix=0b01001011; break;   //A
		case 0x1a: Matrix=0b01000111; break;   //Y
		//0011		2	W	S	X
		case 0x1E: Matrix=0b11001110; break;   //2
		case 0x1D: Matrix=0b11001101; break;   //W
		case 0x1B: Matrix=0b11001011; break;   //S
		case 0x22: Matrix=0b11000111; break;   //X
		//0100		3	E	D	C
		case 0x26: Matrix=0b00101110; break;   //3
		case 0x24: Matrix=0b00101101; break;   //E
		case 0x23: Matrix=0b00101011; break;   //D
		case 0x21: Matrix=0b00100111; break;   //C
		//0101		4	R	F	V
		case 0x25: Matrix=0b10101110; break;   //4
		case 0x2d: Matrix=0b10101101; break;   //R
		case 0x2b: Matrix=0b10101011; break;   //F
		case 0x2a: Matrix=0b10100111; break;   //V
		//0110		5	T	G	B
		case 0x2e: Matrix=0b01101110; break;   //5
		case 0x2c: Matrix=0b01101101; break;   //T
		case 0x34: Matrix=0b01101011; break;   //G
		case 0x32: Matrix=0b01100111; break;   //B
		//0111		6	Z	H	N
		case 0x36: Matrix=0b11101110; break;   //6
		case 0x35: Matrix=0b11101101; break;   //Z
		case 0x33: Matrix=0b11101011; break;   //H
		case 0x31: Matrix=0b11100111; break;   //N
		//1000		7	U	J	M
		case 0x3d: Matrix=0b00011110; break;   //7
		case 0x3c: Matrix=0b00011101; break;   //U
		case 0x3b: Matrix=0b00011011; break;   //J
		case 0x3a: Matrix=0b00010111; break;   //M
		//1001		8	I	K	,
		case 0x3e: Matrix=0b10011110; break;   //8
		case 0x43: Matrix=0b10011101; break;   //I
		case 0x42: Matrix=0b10011011; break;   //K
		case 0x41: Matrix=0b10010111; break;   //,
		//1010		9	O	L	.
		case 0x46: Matrix=0b01011110; break;   //9
		case 0x44: Matrix=0b01011101; break;   //O
		case 0x4b: Matrix=0b01011011; break;   //L
		case 0x49: Matrix=0b01010111; break;   //.
		//1011		0	P	*	/
		case 0x45: Matrix=0b11011110; break;   //0
		case 0x4d: Matrix=0b11011101; break;   //P
		case 0x4c: Matrix=0b11011011; break;   //*
		case 0x7c: Matrix=0b11011011; break;   //*	Nummernblock
		case 0x4a: Matrix=0b11010111; break;   ///	Nummernblock
		//1100		DEL	+	-	ENTER
		case 0x71: Matrix=0b00111110; break;   //DEL
		case 0x79: Matrix=0b00111101; break;   //+	Nummernblock
		case 0x5b: Matrix=0b00111101; break;   //+
		case 0x5d: Matrix=0b00111011; break;   //-
		case 0x7b: Matrix=0b00111011; break;   //-	Nummernblock
		case 0x5a: Matrix=0b00110111; break;   //ENTER
                default: Matrix=0xff; break;
                //default: break;

            }

            if (Matrix==0xff)
            {
               STATUS_LED = 0;
            }
            else
            {
            CPLD=Matrix;
               STATUS_LED = 1;
            }
        }

    }
}



void delay_100ms(unsigned char n)
{
     while (n-- != 0){__delay_ms(100);}
     return;
}


unsigned char PS2_Lesen()
{
    unsigned char i, tmp, w;

    w=PS2_Bit_Holen();
    for (i=0;i!=8;i++)
    {
        tmp=(unsigned char)(tmp>>1u);
        w=PS2_Bit_Holen();
        tmp=(unsigned char)(w|tmp);
        w=(unsigned char)(w|0b01111111u);
        tmp=(unsigned char)(tmp&w);
    }
    w=PS2_Bit_Holen();
    w=PS2_Bit_Holen();
    return tmp;

}


unsigned char PS2_Bit_Holen()
{
    //Warte auf Taktleitung = 1
    while (PS2_TAKT == 0){}
    //Warte auf Taktleitung = 0
    while (PS2_TAKT == 1){ }
    if (PS2_DATEN == 0){return 0b00000000;}
    else {return 0b10000000;}
}